package at.jku.ssw.fp.sect02_1;

/**
 * Functional interface mapping a value to a result. 
 * 
 * @author Herbert Praehofer
 *
 * @param <T> the type of the function argument
 * @param <R> the type of the function result 
 * @see java.util.function.Function
 */
@FunctionalInterface
public interface Function<T, R> {
  
  /**
   * Applies the argument, returns a result. 
   * @param t the argument value
   * @return the function result
   */
  R apply(T t);
}
