package at.jku.ssw.fp.sect02_3;

import java.util.List;

import at.jku.ssw.fp.sect02_1.Function;
import at.jku.ssw.fp.util.IntRef;

/**
 * Demos showing closures. 
 * 
 * @author Herbert Praehofer
 *
 */
public class Demo3_Closures {

  public static void main(String[] args) {

    Function<Double, Double> sqrShifted = shift(x -> x * x, 1.0);
    double sqr3 = sqrShifted.apply(3.0);
    System.out.println(sqr3);

    List<Integer> intList = List.of(1, 2, 3);
    // int sum = 0;
    // intList.forEach(x -> sum = sum + x); // Compilerfehler

    IntRef sum = IntRef.of(0);
    intList.forEach(x -> sum.value = sum.value + x);
    System.out.println(sum.value);

  }

  public static Function<Double, Double> shift(Function<Double, Double> func, double delta) {
    return x -> func.apply(x - delta);
  }

}
