package at.jku.ssw.fp.sect02_3;

/**
 * Functional interface with exception
 * @author hp
 *
 * @param <T> the type of the argument
 * @param <R> the type of the result
 * @param <X> the type of the exception thrown
 */
public interface FunctionWithExcpt<T, R, X extends Exception> {
  /**
   * Applies the value, returns a result and possibly throws an exception.
   * @param t the value
   * @return the result
   * @throws X the exception possibly thrown
   */
  R apply(T t) throws X;
}
