package at.jku.ssw.fp.sect03_1;

import at.jku.ssw.fp.util.Pair;

/**
 * Demos showing impure and pure functions. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Demo1_GetWord {

  public static void main(String[] args) {
    StringBuilder text = new StringBuilder("first second third ");
    String w1 = getWordImpure(text); // liefert Wort "first"
    String w2 = getWordImpure(text); // liefert Wort "second"
    System.out.println(w1);
    System.out.println(w2);

    String text2 = "first second third ";
    Pair<String, String> wordRest1 = getWordPure(text2);
    Pair<String, String> wordRest2 = getWordPure(text2);
    System.out.println(wordRest1.fst);
    System.out.println(wordRest2.fst);

    Pair<String, String> wordRest12 = getWordPure(text2);
    Pair<String, String> wordRest22 = getWordPure(wordRest1.snd);
    System.out.println(wordRest12.fst);
    System.out.println(wordRest22.fst);

  }

  static String getWordImpure(StringBuilder text) {
    int i = text.indexOf(" ");
    String word = text.substring(0, i);
    text.delete(0, i + 1); // Seiteneffekt
    return word;
  }

  static Pair<String, String> getWordPure(String text) {
    int i = text.indexOf(" ");
    String word = text.substring(0, i);
    String rest = text.substring(i + 1);
    return Pair.of(word, rest);
  }

}
