package at.jku.ssw.fp.sect03_1;

import java.util.HashMap;
import java.util.Map;
import java.util.function.IntToLongFunction;

/**
 * Demo of memoization of fibonacci numbers. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Demo4_Fib {

  public static void main(String[] args) {

    long fib47 = fib(47);
    System.out.println(fib47);

    IntToLongFunction fibFn = new IntToLongFunction() {
      Map<Integer, Long> cache = new HashMap<Integer, Long>();

      @Override
      public long applyAsLong(int n) {
        if (n == 0 || n == 1)
          return 1;
        Long fibN = cache.get(n);
        if (fibN == null) {
          fibN = this.applyAsLong(n - 1) + this.applyAsLong(n - 2);
          cache.put(n, fibN);
        }
        return fibN;
      }
    };

    fib47 = fibFn.applyAsLong(47);
    System.out.println(fib47);

    long fib477 = fibFn.applyAsLong(477);
    System.out.println(fib477);

  }

  static long fib(long n) {
    if (n == 0 || n == 1)
      return 1;
    else
      return fib(n - 1) + fib(n - 2);
  }

}
