package at.jku.ssw.fp.sect03_2;

import java.util.Map;
import java.util.Optional;

import at.jku.ssw.fp.person.Person;

/**
 * Demo of working with optional. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Demo_Optional {

  public static void main(String[] args) {
    Map<String, Person> nameToPersonMap = Map.of("Franz", new Person("Franz"), "Hans", new Person("Hans"), "Anna",
        new Person("Anna"));

    Object value = nameToPersonMap.get("Franz");
    System.out.println(value);
    value = nameToPersonMap.get("NN");
    System.out.println(value);

    Optional<Person> optionalPerson = lookup(nameToPersonMap, "Hans");
    if (optionalPerson.isPresent()) {
      Person person = optionalPerson.get();
      System.out.println(person);
    } else {
      System.out.println("Not availabe Hans");
    }

    Person person = optionalPerson.orElseGet(() -> new Person("NN"));
    System.out.println(person);

    Person person2 = lookup(nameToPersonMap, "Xaver").orElseGet(() -> new Person("NN"));
    System.out.println(person2);

  }

  static <A, B> Optional<B> lookup(Map<A, B> map, A key) {
    return Optional.ofNullable(map.get(key));
  }

}
