package at.jku.ssw.fp.sect04_1;

import java.util.Random;

import at.jku.ssw.fp.coll.FList;

/**
 * Demo for higher-order functions of functional list {@link FList}.
 *
 * @author Herbert Praehofer
 */
public final class Demo1_FListHOF {

  public static void main(String[] args) {

    FList<String> words = FList.of("lambda", "Java", "functional", "programming");
    words.forEach(w -> {
      System.out.println(w);
    });

    FList<Integer> lengths = words.map(w -> w.length());
    System.out.println();
    lengths.forEach(w -> {
      System.out.println(w);
    });

    FList<String> longWords = words.filter(w -> w.length() > 5);
    System.out.println();
    longWords.forEach(w -> {
      System.out.println(w);
    });

    Random rand = new Random();
    FList<Integer> randInts = FList.generate(10, () -> rand.nextInt());

    System.out.println();
    randInts.forEach(w -> {
      System.out.println(w);
    });

    int totalLength = words.reduce(0, (length, e) -> length + e.length());
    System.out.println();
    System.out.println(totalLength);

  }

}
