package at.jku.ssw.fp.sect04_4.cmd_fp;

/**
 * A command object. Consists of a do and an undo action.
 *
 * @author Herbert Prähofer
 *
 */
public class Command {

  /** The do action */
  public final Runnable doAction;

  /** The undo action */
  public final Runnable undoAction;

  /**
   * Constructor initializing the do and the undo action.
   *
   * @param doCmd the do action
   * @param undoCmd the undo action
   */
  public Command(Runnable doCmd, Runnable undoCmd) {
    this.doAction = doCmd;
    this.undoAction = undoCmd;
  }

}
