package at.jku.ssw.fp.sect04_4.cmd_fp;

/**
 * Simple class simulating actions of a text editor.
 *
 * @author Herbert Prähofer
 *
 */
public class TextEditor {

  private final StringBuilder text = new StringBuilder("Dies ist eine Beispieltext!");

  /**
   * Adds a text at a given position.
   *
   * @param pos the position
   * @param textToAdd the text to add
   */
  public void addText(int pos, String textToAdd) {
    CmdHandler.getInstance()
        .doCmd(new Command(() -> text.insert(pos, textToAdd), () -> text.delete(pos, pos + textToAdd.length())));
  }

  /**
   * Deletes a text at a given position.
   *
   * @param pos the position
   * @param length the length of the text to delete
   */
  public void deleteText(int pos, int length) {
    final String textDeleted = text.substring(pos, length);
    CmdHandler.getInstance()
        .doCmd(new Command(() -> text.delete(pos, pos + length), () -> text.insert(pos, textDeleted)));
  }

}
