package at.jku.ssw.fp.sect04_4.cmd_nofp;


/**
 * Simple class simulating actions of a text editor.
 *
 * @author Herbert Prähofer
 *
 */public class TextEditor {

  private final StringBuilder text = new StringBuilder("Dies ist eine Beispieltext!");

  /**
   * Adds a text at a given position.
   *
   * @param pos the position
   * @param textToAdd the text to add
   */
  public void addText(int pos, String textToAdd) {
    CmdHandler.getInstance().doCmd(new AddTextCommand(text, pos, textToAdd));
  }

  /**
   * Deletes a text at a given position.
   *
   * @param pos the position
   * @param length the length of the text to delete
   */
  public void deleteText(int pos, int length) {
    CmdHandler.getInstance().doCmd(new DeleteTextCommand(text, pos, length));
  }

}
