package at.jku.ssw.fp.sect04_4.visitor_nofp;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.And;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Lit;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Not;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Or;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Var;


/**
 * Demo showing visitor for expressions.
 *
 * @author Herbert Praehofer
 */
public class Demo_ExprVisitor {

  public static void main(String[] args) {

    // (true && x) || ! (y && false)
    Expr expr =
        new Or(
          new And(
            new Lit(true),
            new Var("x")
          ),
          new Not(
            new And(
              new Var("y"),
              new Lit(false)
            )
          )
        );


    System.out.println("expr = " + mkString(expr));
  }

  public static String mkString(Expr expr) {
    return expr.accept(new ToStringVisitor());
  }

}
