package at.jku.ssw.fp.sect04_4.visitor_nofp;

import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.And;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Lit;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Not;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Or;
import at.jku.ssw.fp.sect04_4.visitor_nofp.Expr.Var;

/**
 * Expression visitor for creating a string representation.
 *
 * @author Herbert Prähofer
 *
 */
public class ToStringVisitor implements Visitor<String> {

  @Override
  public String visitLit(Lit lit) {
    return String.valueOf(lit.value);
  }

  @Override
  public String visitVar(Var vbl) {
    return vbl.name;
  }

  @Override
  public String visitNot(Not not) {
    return "! " + not.sub.accept(this);
  }

  @Override
  public String visitAnd(And and) {
    return "(" + and.left.accept(this) + " && " +
           and.right.accept(this) + ")";
  }


  @Override
  public String visitOr(Or or) {
    return "(" + or.left.accept(this) + " || " + or.right.accept(this) + ")";
  }

}
