package at.jku.ssw.fp.sect04_6;

import static at.jku.ssw.fp.sect04_6.Lazy.breadthFirstIterable;
import static at.jku.ssw.fp.sect04_6.Lazy.find;

import java.io.IOException;
import java.util.Optional;

import at.jku.ssw.fp.sect04_3.puzzle.Puzzle;;

/**
 * Demo showing search for solution in puzzle using lazy iterator. 
 * 
 * @author Herbert Praehofer
 */
public class Demo3_PuzzleIterable {

  public static void main(String[] args) throws IOException {

    System.out.println("\nPuzzle:");

    Puzzle start = Puzzle.from(8, 0, 3, 2, 7, 5, 4, 6, 1); // Puzzle.shuffled();

    Optional<Puzzle> optSolution = 
        find(breadthFirstIterable(start, 
                      p -> p.getNextStates()), 
                      p -> p.isSolution());


    if (optSolution.isPresent()) {
      Puzzle sol = optSolution.get();
      System.out.println("Breadth-first: solution found with " + sol.getMoveHistory().size() + " moves");
      for (Puzzle p : sol.getStateHistory()) {
        p.print(System.out);
      }
      sol.print(System.out);
    } else {
      System.out.println("Breadth-first: no solution");
    }

  }

}
