package at.jku.ssw.fp.sect05_2;

/**
 * Comparable person class. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Person implements Comparable<Person> {

  private final String name;
  private final String firstName;
  private int age;

  public Person(String name, String firstName, int age) {
    super();
    this.name = name;
    this.firstName = firstName;
    this.age = age;
  }

  public String getName() {
    return name;
  }

  public String getFirstName() {
    return firstName;
  }

  public int getAge() {
    return age;
  }

  public void setAge(int age) {
    this.age = age;
  }

  @Override
  public String toString() {
    return "Person [name=" + name + ", firstName=" + firstName + ", age=" + age + "]";
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((firstName == null) ? 0 : firstName.hashCode());
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Person other = (Person) obj;
    if (firstName == null) {
      if (other.firstName != null)
        return false;
    } else if (!firstName.equals(other.firstName))
      return false;
    if (name == null) {
      if (other.name != null)
        return false;
    } else if (!name.equals(other.name))
      return false;
    return true;
  }

  @Override
  public int compareTo(Person o) {
    int c = name.compareTo(o.name);
    if (c == 0) {
      c = firstName.compareTo(o.firstName); 
    }
    return c;
  }

}
