package at.jku.ssw.fp.sect05_3.parser;

import java.util.Scanner;

import at.jku.ssw.fp.coll.FList;
import at.jku.ssw.fp.expr.Expr;

/**
 * Demo showing parsing expressions. 
 * Allows to enter string for Boolean expressions in prefix notation and 
 * tries to parse the input string. Terminate with empty input. 
 * 
 * @author Herbert Praehofer
 */
public abstract class Demo2_ExprParser {

  /**
   * Allows to enter string for Boolean expressions in prefix notation and 
   * tries to parse the input string. 
   * Terminate with empty input. 
   * 
   * @param args application arguments (not used)
   */
  public static void main(String[] args) {
    
    ExprParser exprParser = new ExprParser();
    FList<String> tokens = FList.of("|| && true x ! && y false".split(" ")); 
    Result<Expr> r = exprParser.exprParser().apply(tokens);
    System.out.println(r.result); 

    Scanner scanner = new Scanner(System.in);
    System.out.println("Input expression in prefix notation: ");
    String input = scanner.nextLine();
    while (input.length() != 0) {
      Result<? extends Expr> r1 = exprParser.parse(input);
      System.out.println(r1);
      System.out.println();
      System.out.println("Input expression in prefix notation: ");
      input = scanner.nextLine();
    }
    scanner.close();
  }

}
