package at.jku.ssw.fp.sect05_4.dsl;

/**
 * Variable with Boolean mutable value in a controller application.
 *
 * @author Herbert Praehofer
 *
 */
public class BVar {

  /** Field for the mutable value of the variable. */
  private boolean value;

  /**
   * Constructor initializing the variable value.
   *
   * @param initial the initial value
   */
  public BVar(boolean initial) {
    this.value = initial;
  }

  /**
   * Gets the variable value.
   *
   * @return the variable value
   */
  public boolean get() {
    return value;
  }

  /**
   * Sets the variable value.
   *
   * @param value the new value
   */
  public void set(boolean value) {
    this.value = value;
  }

  @Override
  public String toString() {
    return "[" + value + "]";
  }

}
