package at.jku.ssw.fp.sect05_4.dsl;

/**
 * Variable with double mutable value in a controller application.
 *
 * @author Herbert Praehofer
 */
public class DVar {

  /** Field for the mutable value of the variable. */
  private double value;

  /**
   * Constructor initializing the variable value.
   *
   * @param initial the initial value
   */
  public DVar(double initial) {
    this.value = initial;
  }

  /**
   * Gets the variable value.
   *
   * @return the variable value
   */
  public double get() {
    return value;
  }

  /**
   * Sets the variable value.
   *
   * @param value the new value
   */
  public void set(double value) {
    this.value = value;
  }

  @Override
  public String toString() {
    return "[" + value + "]";
  }

}
