package at.jku.ssw.fp.sect05_4.dsl;

/**
 * Variable with integer mutable value in a controller application.
 *
 * @author Herbert Praehofer
 */
public class IVar {

  /** Field for the mutable value of the variable. */
  private int value;

  /**
   * Constructor initializing the variable value.
   *
   * @param initial the initial value
   */
  public IVar(int initial) {
    this.value = initial;
  }

  /**
   * Gets the variable value.
   *
   * @return the variable value
   */
  public int get() {
    return value;
  }

  /**
   * Sets the variable value.
   *
   * @param value the new value
   */
  public void set(int value) {
    this.value = value;
  }

  @Override
  public String toString() {
    return "[" + value + "]";
  }

}
