package at.jku.ssw.fp.sect05_4.dsl;

/**
 * Variable with generic mutable value in a controller application.
 *
 * @author Herbert Praehofer
 *
 * @param <T> the type of the variable value
 */
public class Var<T> {

  /** Field for the mutable value of the variable. */
  private T value;

  /**
   * Constructor initializing the variable value.
   *
   * @param initial the initial value
   */
  public Var(T initial) {
    this.value = initial;
  }

  /**
   * Gets the variable value.
   *
   * @return the variable value
   */
  public T get() {
    return value;
  }

  /**
   * Sets the variable value.
   *
   * @param value the new value
   */
  public void set(T value) {
    this.value = value;
  }

  @Override
  public String toString() {
    return "[" + value + "]";
  }

}
