package at.jku.ssw.fp.sect06_2;

import static at.jku.ssw.fp.coll.Tree.empty;
import static at.jku.ssw.fp.coll.Tree.of;

import java.util.List;

import at.jku.ssw.fp.coll.Tree;

/**
 * Demo showing reducible trees. 
 * 
 * @author Herbert Praehofer
 */
public class Demo2_ReducibleTree {

  @SuppressWarnings("unused")
  public static void main(String[] args) {

    Tree<String> tree = Tree.of("Franz", Tree.of("Fritz", Tree.of("Berta", empty(), empty()), empty()),
        Tree.of("Xaver", empty(), empty()));

    Tree<String> tree2 = of("Hans", of("Fritz", of("Hubert"), of("Xaver")), of("Berta", of("Susi"), empty()));

    // Concatenating names 

    String a = Reducible.from(tree).reduce(Monoids.stringMonoid);
    System.out.println(a);

    // Count

    int count = Reducible.from(tree).count();
    System.out.println(count);

    // Sum of length of names 

    int ll = Reducible.from(tree).reduceMap(n -> n.length(), Monoids.intPlusMonoid);
    System.out.println(ll);

    // toList

    List<String> names = Reducible.from(tree).toList();
    System.out.println(names);

  }

}
