package at.jku.ssw.fp.sect06_3;

import at.jku.ssw.fp.coll.FList;

/**
 * Class for parse exceptions.
 * Contains a message and stores the rest of tokens.
 *
 * @author Herbert Praehofer
 *
 */
@SuppressWarnings("serial")
public class ParseException extends Exception {

  /** List of tokens left */
  private final FList<String> input;

  /**
   * Constructor setting a message and the list of tokens left.
   *
   * @param message the message
   * @param input the list of tokens left
   */
  public ParseException(String message, FList<String> input) {
    super(message);
    this.input = input;
  }

  /**
   * Gets the list of tokens left.
   *
   * @return the list of tokens left
   */
  public FList<String> getInput() {
    return input;
  }

}
