package at.jku.ssw.fp.sect06_3_4;

import static at.jku.ssw.fp.util.When.is;
import static at.jku.ssw.fp.util.When.when;

import java.util.Map;

import at.jku.ssw.fp.expr.Expr;
import at.jku.ssw.fp.expr.Expr.And;
import at.jku.ssw.fp.expr.Expr.Lit;
import at.jku.ssw.fp.expr.Expr.Not;
import at.jku.ssw.fp.expr.Expr.Or;
import at.jku.ssw.fp.expr.Expr.Var;

/**
 * Demo of evaluation of expressions with Monad Id.
 * 
 * @author Herbert Praehofer
 */
public class Demo2_ExprEvalId {

    static Id<Boolean> evalOpt(Expr expr, Map<String, Boolean> bds) {
        return when(expr,
                is(Lit.class, lit -> Id.of(lit.value)),
                is(Var.class, vbl -> Id.of(bds.get(vbl.name))),
                is(Not.class, not ->
                        evalOpt(not.sub, bds)
                                .flatMap(subVal -> Id.of(! subVal))),
                is(And.class, and ->  evalOpt(and.left, bds)
                        .flatMap(leftVal -> evalOpt(and.right, bds)
                                .flatMap(rightVal -> Id.of(leftVal && rightVal)))),
                is(Or.class, or ->  evalOpt(or.left, bds)
                        .flatMap(leftVal -> evalOpt(or.right, bds)
                                .flatMap(rightVal -> Id.of(leftVal || rightVal))))
        );
    }

}
