package at.jku.ssw.fp.sect07_1;

/**
 * Class representing articles with name and price. 
 * 
 * @author Herbert Praehofer
 *
 */
public class Article {
  
  /** The name of the article */ 
  public final String name;
  
  /** The price of the article */
  public final double price;

  /**
   * Constructor initializing name and price. 
   * 
   * @param name the name of the article 
   * @param price the price of the article 
   */
  public Article(String name, double price) {
    super();
    this.name = name;
    this.price = price;
  }

  @Override
  public int hashCode() {
    final int prime = 31;
    int result = 1;
    result = prime * result + ((name == null) ? 0 : name.hashCode());
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj)
      return true;
    if (obj == null)
      return false;
    if (getClass() != obj.getClass())
      return false;
    Article other = (Article) obj;
    if (name == null) {
      if (other.name != null)
        return false;
    } else if (!name.equals(other.name))
      return false;
    return true;
  }

  @Override
  public String toString() {
    return "Article [name=" + name + ", price=" + price + "]";
  }

}
