package at.jku.ssw.fp.sect07_1;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Demo of grouping articles based on price. 
 * 
 * @author Herbert Praehofer
 */
public class ArticleGroupingDemo {

  public static void main(String[] args) {

    Stream<Article> articleStream = Stream.of(new Article("A", 700), new Article("B", 1500), new Article("C", 1200),
        new Article("D", 200), new Article("E", 100), new Article("F", 800));

    Map<PriceGroups, List<Article>> articleGroups = articleStream
        .collect(Collectors.groupingBy(article -> PriceGroups.fromPrice(article.price)));

    System.out.println(articleGroups);

  }

}
