package at.jku.ssw.fp.sect07_1;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * Demo of basic streams operations. 
 * 
 * @author Herbert Praehofer
 */
public class Demo1_ArticleStream {

  public static void main(String[] args) {

    List<Article> articles = List.of(new Article("A", 1500), new Article("B", 700), new Article("C", 1200),
        new Article("D", 500), new Article("E", 600), new Article("F", 1100));

    List<String> cheapArticleNames = 
        articles.stream()
          .filter(a -> a.price < 1000.0)
          .sorted(Comparator.comparingDouble((Article a) -> a.price))
          .map(a -> a.name)
          .collect(Collectors.toList());
    System.out.println(cheapArticleNames); 
    
    List<String> cheapArticleNames2 = new ArrayList<String>();
    for (Article a : articles) {
      if (a.price < 1000.0) {
        cheapArticleNames2.add(a.name);
      }
    }
    System.out.println(cheapArticleNames2); 

  }

}
