package at.jku.ssw.fp.sect07_1;

import java.util.Optional;
import java.util.stream.Stream;

import at.jku.ssw.fp.coll.FList;

/**
 * Demo of lazy and eager computations. 
 * 
 * @author Herbert Praehofer
 */
public class Demo2_LazyVsEager {

  public static void main(String[] args) {

    FList<Article> articles = FList.of(new Article("A", 1500), new Article("B", 700), new Article("C", 1200),
        new Article("D", 500), new Article("E", 600), new Article("F", 800));
    System.out.println(articles);

    FList<String> cheapArticleNames = 
        articles
            .filter(a -> a.price < 1000.0)
            .map(a -> a.name);
    System.out.println(cheapArticleNames);
    
    String cheapArticleName = 
        articles.filter(a -> a.price < 1000.0)
                .map(a -> a.name)
                .head(); 
    System.out.println(cheapArticleName);

    Optional<String> optCheapArticleName = 
        articles.stream()
                .filter(a -> a.price < 1000.0)
                .map(a -> a.name)
                .findFirst(); 
    System.out.println(optCheapArticleName);

    
    Stream<Integer> power2 = Stream.iterate(2, x -> x * 2);
    power2.limit(10).forEach(System.out::println);   
    
  }

}
