package at.jku.ssw.fp.sect07_1;

/**
 * Enumeration for price groups of articles. 
 * 
 * @author Herbert Praehofer
 *
 */
public enum PriceGroups {

  LOW, MEDIUM, HIGH;

  private static final double LOW_BOUND = 500.0, HIGH_BOUND = 1000.0;

  /**
   * Returns the group based on a price value.
   * 
   * @param price the price value
   * @return the price group
   */
  public static PriceGroups fromPrice(double price) {
    if (price < LOW_BOUND)
      return PriceGroups.LOW;
    else if (price < HIGH_BOUND)
      return PriceGroups.MEDIUM;
    else
      return PriceGroups.HIGH;
  }
}
