package at.jku.ssw.fp.sect07_6;

import java.util.stream.Collectors;
import java.util.stream.Stream;

/**
 * Demo showing the effect of stateful operation sorted. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Demo2_Sorted {

  public static void main(String[] args) {

    System.out.println("No sorted:");
    Stream<String> stream = Stream.of("C", "B", "A");
    stream.map(s -> s.toLowerCase()).peek(s -> System.out.format("First map: %s%n", s)).map(s -> s.toUpperCase())
        .peek(s -> System.out.format("Second map: %s%n", s)).collect(Collectors.toList());

    System.out.println("\nWith sorted:");
    stream = Stream.of("C", "B", "A");
    stream.map(s -> s.toLowerCase()).peek(s -> System.out.format("First map: %s%n", s)).sorted()
        .map(s -> s.toUpperCase()).peek(s -> System.out.format("Second map: %s%n", s)).collect(Collectors.toList());

  }

}
