package at.jku.ssw.fp.sect08_1;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.stream.IntStream;
import java.util.stream.Stream;

/**
 * Demos showing parallel stream operations. 
 * 
 * @author Herbert Praehofer 
 *
 */
public class Demo1_ParallelStream {

  @SuppressWarnings("unused")
  public static void main(String[] args) {

    Collection<Integer> someNumbers = Arrays.asList(1, 2, 3);
    Stream< Integer> parallelStream = someNumbers.parallelStream();

    int total = someNumbers.parallelStream()
        .reduce(0, (s, x) -> (s + x), (s1, s2) -> s1 + s2);

    System.out.println("\ntotal: \n" + total);

    int[] intArray = new int[] { 1, 2, 3 };
    IntStream parallelIntStream = Arrays.stream(intArray).parallel();

    int totalSqrs = 
        someNumbers.parallelStream()
          .map(x -> x * x)
          .sequential()
          .reduce(0, (s, x) -> (s + x), (s1, s2) -> s1 + s2);

    System.out.println("\ntotalSqrs: \n" + totalSqrs);

    List<Integer> all = 
        someNumbers.parallelStream()
              .map(x -> x * x)
              .collect(
                () -> new ArrayList<Integer>(), 
                (list, x) -> list.add(x),
                (list1, list2) -> list1.addAll(list2)
              );

    System.out.println("\nall: \n" + all);
  }

}
