package at.jku.ssw.fp.sect08_1;

import static java.util.stream.Collectors.toList;

import java.util.Collection;
import java.util.stream.IntStream;

/**
 * Demos showing parallel stream operations with detailed log information. 
 * 
 * @author Herbert Praehofer 
 *
 */public class Demo2_ParallelStreamWithLog {

  public static void main(String[] args) {

    IntStream someInts = IntStream.rangeClosed(1, 1000);
    Collection<Integer> someNumbers = someInts.boxed().collect(toList());

    int totalSqrsLimit = 
        someNumbers
          .stream()
          .limit(100)
          .peek(e -> Thread.currentThread().getName()).parallel()
          .map(x -> {
            System.out.println(Thread.currentThread().getName());
            return x * x;
          })
          .limit(100)
          .reduce(0, (sum, x) -> (sum + x), (sum1, sum2) -> sum1 + sum2);

    System.out.println(totalSqrsLimit); 
    
  }

}
