package at.jku.ssw.fp.sect08_2;

import java.util.ArrayList;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.Future;

/**
 * Demos showing the effect of thread pool configurations. 
 * 
 * @author Herbert Praehofer
 *
 */
public class Demo2_ThreadPoolProperty {

  @SuppressWarnings("unused")
  public static void main(String[] args) throws InterruptedException, ExecutionException {
    ForkJoinPool commonPool = ForkJoinPool.commonPool();

    int parallelism = ForkJoinPool.commonPool().getParallelism();

    int cores = Runtime.getRuntime().availableProcessors();
    System.out.println("Cores = " + cores);

    System.out.println("Common pool parallelism = " + commonPool.getParallelism());
    System.out.println("Common pool size = " + commonPool.getPoolSize());

    ArrayList<Integer> someNumbers = new ArrayList<Integer>();
    for (int i = 0; i < 100; i++) {
      someNumbers.add(i);
    }

    ForkJoinPool customThreadPool = new ForkJoinPool(12);
    Future<Integer> totalFtr = customThreadPool.submit(
      () -> someNumbers.parallelStream().reduce(0, 
                                                (s, x) -> s + x, 
                                                (s1, s2) -> s1 + s2) 
    );


    int total = totalFtr.get();
    System.out.println(total);

  }

}
