package at.jku.ssw.fp.sect08_2;

import java.util.LinkedList;
import java.util.Spliterator;

/**
 * An list which returns a {@link TracedSpliterator} as spliterator.
 *
 * @author Herbert Praehofer
 *
 * @param <T> the type of elements
 */
@SuppressWarnings("serial")
class TracedList<T> extends LinkedList<T> {

  /**
   * Returns a {@link TracedSpliterator} as spliterator for this list.
   *
   * @return a spliterator with trace
   */
  @Override
  public Spliterator<T> spliterator() {
    return new TracedSpliterator<T>(super.spliterator(), "");
  }

}