package at.jku.ssw.fp.sect10;

import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/** 
 * Class with a set of constants used in examples. 
 * 
 * @author Herbert Praehofer
 */
public class Constants {
	
  /** A random number generator */
	public static final Random RAND = new Random(); 
	
	/** A default parallelism for the thread pool */
	public static final int PARALLELISM = 10;
	
	/** A tread pool */ 
	public static final ExecutorService executor = Executors.newFixedThreadPool(PARALLELISM); 

	/** A constant for simulating a delay in an operation */
	public static int DELAY_CONST = 100;
	
  /** A constant for generating a variation in a delay of an operation */
	public static int DELAY_VARIATION = 3000;
	
	/** A probability for a exception */
	public static double EXCPT_PROP = 0.0;
	
	/** A probability for a timeout */
	public static double TIMEOUT_PROP = 0.0;
	
	/** A constant for a timeout */
	public static int TIMEOUT_DELAY = 20_000;

}
