package at.jku.ssw.fp.sect10_4;

import java.util.Random;
import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;

/**
 * Demo showing {@link Observable#distinctUntilChanged()}.
 *
 * @author Herbert Praehofer
 */
public class Demo2_DistinctUntilChanged {

	private static final Random RAND = new Random();

	public static void main(String[] args) throws InterruptedException {

		Observable<Long> sensorObservable =
		    Observable
				.interval(1,  TimeUnit.SECONDS)
				.doOnNext(i -> System.out.println(i))
				.map(r -> RAND.nextDouble() * 2)
				.doOnNext(r -> System.out.println("value = " + r))
				.map(x -> Math.round(x));

		sensorObservable
      .distinctUntilChanged()
      .forEach(x -> System.out.println("new value = " + x));

		Thread.sleep(22000);
	}

}
