package at.jku.ssw.fp.sect10_4;

import java.util.Random;
import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;

/**
 * Demo showing {@link Observable#scan(io.reactivex.functions.BiFunction)}.
 *
 * @author Herbert Praehofer
 */
public class Demo3_Scan {

	private static final Random RAND = new Random();

	public static void main(String[] args) throws InterruptedException {

		Observable<Double> measObservables =
			Observable
				.interval(1,  TimeUnit.SECONDS)
				.doOnNext(i -> System.out.println(i))
				.map(i -> RAND.nextDouble() * 3)
				.map(x -> (double)Math.round(x))
				.distinctUntilChanged();

		Observable<Double> glidingAvrgObs =
		    measObservables.scan((avrg, curr) -> (avrg * 0.8 + curr) / 1.8);

		glidingAvrgObs.forEach(System.out::println);

		Thread.sleep(20000);
	}

}
