package at.jku.ssw.fp.sect10_4;

import io.reactivex.Observable;

/**
 * Demo showing the use of {@link Observable#buffer(int, int)}.
 *
 * @author Herbert Praehofer
 */

public class Demo5_Buffer {

	public static void main(String[] args) throws InterruptedException {

		Observable<Integer> numObs = Observable.just(1, 2, 3, 4, 5, 6, 7);
		numObs
			.buffer(3, 1)
			.subscribe(System.out::println,
					System.out::println,
					System.out::println);

		System.out.println();

		Observable<Double> measurementObs = Observable.fromArray(
			new Double[] {
				1.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0, 2.0, 3.0,
				1.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0, 2.0, 3.0,
				1.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0, 2.0, 3.0,
				1.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0, 2.0, 3.0,
				1.0, 2.0, 3.0, 3.0, 2.0, 2.0, 1.0, 1.0, 2.0, 3.0
			});

		measurementObs
	  .buffer(4, 1)
	  .map(xs -> {
	    switch(xs.size()) {
	      case 4: return 0.4 * xs.get(3) + 0.3 * xs.get(2) +
	                0.2 * xs.get(1) + 0.1 * xs.get(0);
	      case 3: return 0.5 * xs.get(2) + 0.3 * xs.get(1) +
	                0.2 * xs.get(0);
	      case 2: return 0.7 * xs.get(1) + 0.3 * xs.get(0);
	      case 1: return xs.get(0);
	      default: return 0.0;
	    }
	  })
	  .subscribe(y -> System.out.println(y));



		Thread.sleep(20000);
	}

}
