package at.jku.ssw.fp.sect10_4;

import static java.util.concurrent.TimeUnit.MILLISECONDS;

import io.reactivex.Observable;

/**
 * Demo showing {@link Observable#withLatestFrom(io.reactivex.ObservableSource, io.reactivex.functions.BiFunction)}.
 *
 * @author Herbert Praehofer
 */
public class Demo7_WithLatestFrom {

	public static void main(String[] args) throws InterruptedException {

	  Observable<Long> minObs =
	      Observable.interval(0, 60000, MILLISECONDS);
	  Observable<Long> secObs =
	      Observable.interval(1, 1000, MILLISECONDS);

	  secObs.withLatestFrom(minObs,
	                (s, m) -> String.format("%02d:%02d", m % 60,s%60))
	    .subscribe(System.out::println);

		Thread.sleep(90_000);
	}

}
