package at.jku.ssw.fp.sect10_5;

import at.jku.ssw.fp.sect07_1.Article;
import io.reactivex.Observable;
import io.reactivex.schedulers.Schedulers;

/**
 * Demo program showing the how to use {@link Observable#subscribeOn} for
 * asynchronous event processing.
 *
 * @author Herbert Praehofer
 */
public class Demo2_SubscribeOn {

	public static void main(String[] args) throws InterruptedException {

		Observable<Article> articleObservable =
			Observable.just(
						new Article("A", 1500),
						new Article("B", 700),
						new Article("C", 1200),
						new Article("D", 5000),
						new Article("E", 600)
					)
				.subscribeOn(Schedulers.computation());
//				.subscribeOn(Schedulers.io())
//				.subscribeOn(Schedulers.single())
//				.subscribeOn(Schedulers.from(executor))
//				.subscribeOn(Schedulers.newThread())
//				.subscribeOn(Schedulers.trampoline());

		articleObservable
			.subscribe(
				a -> System.out.println(Thread.currentThread().getName() + ": " + a),
				e -> System.out.println(Thread.currentThread().getName() + ": " + "Error event: " + e),
				() -> System.out.println(Thread.currentThread().getName() + ": " + "Completed!")
			);

		System.out.println(Thread.currentThread().getName() + ": " + "Subscribed!");

		Thread.sleep(3_000);

	}

}
