package at.jku.ssw.fp.sect10_6;

import java.util.List;

import io.reactivex.Observable;
import io.reactivex.Observer;

/**
 * Demo showing an exception due to an unhandled {@link Observer#onError(Throwable)} event.
 *
 * @author Herbert Praehofer
 */
public class Demo3_OnErrorNotImplementedException {

	public static void main(String[] args) throws InterruptedException {

		List<Integer> numbers = List.of(3, 10, 5, 0, 2, 4, 6);

		// --- Exception in Anwenderprogramm  ---

		System.out.println("Exception in Anwenderprogramm:");

		Observable<Integer> quotObservable =
				Observable.create(emitter -> {
					for (int x : numbers) {
						try {
							 emitter.onNext(100 / x);
						} catch (Exception e) {
							 emitter.onError(e);
						}
					}

				});

		quotObservable.subscribe(
					div -> System.out.println("Result = " + div)
				);

	}

}
