package at.jku.ssw.fp.sect10_6;

import java.util.List;

import io.reactivex.Observable;
import io.reactivex.Single;

/**
 * Demo showing error handling with {@link Observable#onErrorReturn}.
 *
 * @author Herbert Praehofer
 */
public class Demo4_OnErrorReturn {


	public static void main(String[] args) throws InterruptedException {

		List<Integer> numbers = List.of(3, 10, 5, 0, 2, 4, 6);

		// --- Exception in application program  ---

		Observable<Integer> quotObservable =
				Observable.create(emitter -> {
					for (int x : numbers) {
						try {
							 emitter.onNext(100 / x);
						} catch (Exception e) {
							 emitter.onError(e);
						}
					}

				});

		quotObservable
  	  .onErrorReturn(excpt -> -1)
  	  .subscribe(
  	      quot -> System.out.println("Result = " + quot),
  	      excpt -> System.out.println("Error = " + excpt),
  	      () -> System.out.println("Completed!")
  	    );


		Single<Integer> xSingle = Single.just(0);
		xSingle
  	  .map(x -> 100 / x)
  	  .onErrorReturn(excpt -> -1)
  	  .subscribe( quot -> System.out.println("Result = " + quot));

	}
}
