package at.jku.ssw.fp.sect10_7;

import static at.jku.ssw.fp.util.Util.delay;

import java.util.Random;
import java.util.concurrent.TimeUnit;

import io.reactivex.Observable;

/**
 * Demo showing reduction of events by {@link Observable#throttleFirst}.
 *
 * @author Herbert Praehofer
 */
public class Demo1_Sample_ThrottleFirst {

  private static final int PERIOD = 1500;
  private static final Random RAND = new Random();

	public static void main(String[] args) {

	    Observable<Double> measObservables =
	        Observable
	          .interval(1,  TimeUnit.SECONDS)
	          .doOnNext(i -> System.out.println(i))
	          .map(i -> RAND.nextDouble() * 3)
	          .map(x -> (double)Math.round(x));

	    measObservables
	      .sample(PERIOD, TimeUnit.MILLISECONDS)
	      .subscribe(System.out::println);

	    measObservables
	      .throttleFirst(PERIOD, TimeUnit.MILLISECONDS)
	      .subscribe(System.out::println);

	    delay(20_000);
    }

}
