package at.jku.ssw.fp.sect10_7;

import static at.jku.ssw.fp.util.Util.delay;

import io.reactivex.Flowable;
import io.reactivex.Observable;
import io.reactivex.schedulers.Schedulers;

/**
 * Demo showing backpressure in {@link Flowable}.
 *
 * @author Herbert Praehofer
 */
public class Demo2_Backpressure {

	public static void main(String[] args) {

		Observable.range(1, 300)
  		.doOnNext(i -> System.out.println("--> Observable produced: " + i))
  		.observeOn(Schedulers.computation())
  		.subscribe(n -> {
  			delay(10);
  			System.out.println("<-- Observable consumed: " + n);
  			});

		delay(10_000);

		Flowable.range(1, 300)
  		.doOnNext(i -> System.out.println("--> Flowable produced: " + i))
  		.observeOn(Schedulers.computation())
  		.subscribe(n -> {
  			delay(10);
  			System.out.println("<-- Flowable consumed: " + n);
  			});

		delay(20_000);

	}

}
