package at.jku.ssw.fp.sect11_3.check4j;

import static at.jku.ssw.fp.sect11_3.check4j.Gens.intsFromTo;
import static at.jku.ssw.fp.sect11_3.check4j.Gens.lists;

import at.jku.ssw.fp.coll.FList; 

/**
 * Demo showing property-based tests. 
 * 
 * @author Herbert Praehofer
 *
 */
public class Demo2_Checks {

  public static void main(String[] args) {
    
    Gen<Integer> ints0To9 = intsFromTo(0, 10); 
    Gen<FList<Integer>> intLists = lists(5, ints0To9);
    Property<FList<Integer>> reverseProperty =
        Property.forAll(intLists, 
                        lst -> lst.reverse().reverse().equals(lst));
    
    var result1 = reverseProperty.check(); 
    System.out.println(result1); 

    Property<FList<Integer>> addProperty =
        Property.forAll(intLists,
             lst -> {
            int x = ints0To9.sample(); 
            FList<Integer> lstX = lst.add(x);
               return lstX.size() == lst.size() + 1 &&
                      lstX.head().equals(x) && lstX.tail() == lst;
          }
        );

    var result2 = addProperty.check(); 
    System.out.println(result2); 

    Property<FList<Integer>> removeProperty =
        Property.forAll(intLists,
          lst -> {
            int x = ints0To9.sample();
            FList<Integer> lstRemoved = lst.remove(x);
            return lstRemoved.size() <= lst.size() &&
                 ! lstRemoved.contains(x);
          }
        );


    var result3 = removeProperty.check(); 
    System.out.println(result3); 

    Property<FList<Integer>> reduceProperty =
        Property.forAll(intLists,
          lst -> {
            int sumRed = lst.reduce(0, Integer::sum);
            int sumArr = 0; 
            for (int i : lst.toArray(new Integer[0])) sumArr += i;
            return sumRed == sumArr;
          }
        );

    var result4 = reduceProperty.check(); 
    System.out.println(result4); 

 }

}
