package at.jku.ssw.fp.sect11_3.check4j;

import static at.jku.ssw.fp.sect11_3.check4j.Gens.intLists;
import static at.jku.ssw.fp.sect11_3.check4j.Gens.intsTo;
import static at.jku.ssw.fp.sect11_3.check4j.Shrinkers.intListShrinker;
import static at.jku.ssw.fp.sect11_3.check4j.Shrinkers.intShrinker;

import at.jku.ssw.fp.coll.FList; 

/**
 * Demo showing property-based tests with shrinking of values. 
 * 
 * @author Herbert Praehofer
 *
 */
public class Demo3_ChecksAndShrinks {

  public static void main(String[] args) {
    
    Property<Integer> divProperty =
        Property.forAll(
            intsTo(Integer.MAX_VALUE),
            x ->  {
              int xDiv2 = x / 2;
              return x == xDiv2 * 2;
            }, 
            intShrinker
        );

    var result1 = divProperty.checkAndShrink(); 
    System.out.println(result1); 
  
    Property<FList<Integer>> reverseChecker =
        Property.forAll(
            intLists,
            lst -> lst.reverse().equals(lst),
            intListShrinker);
 
    var result2 = reverseChecker.checkAndShrink(); 
    System.out.println(result2); 

  }

}
