package at.jku.ssw.fp.sect11_3.check4j;

import java.util.stream.Stream;

/**
 * Interface for shrinkers. 
 * Shrinkers provide shrinked values in a stream. 
 * 
 * @author Herbert Praehofer
 *
 * @param <A> the type of test values
 */
public interface Shrinker<A> {

  /**
   * Returns a stream of shrunk values of the given value. 
   * The simpler values should become first. 
   * 
   * @param x the values to shrink
   * @return the stream of shrunk values
   */
    Stream<A> shrink(A x);

}
